#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "fbgfx.h"
#include "fbevents.h"
#include "tunnel.h"

static void keyboard(int key, int pressed, void *cls);
static void mouse(int bn, int pressed, int x, int y, void *cls);
static void motion(int x, int y, void *cls);

static void *vmem;
static int xsz, ysz, depth;

static int quit;


int main(void)
{
	fbgfx_save_video_mode();
	if(!(vmem = fbgfx_set_video_mode(800, 600, 16))) {
		return 1;
	}
	fbgfx_get_video_mode(&xsz, &ysz, &depth);
	if(depth != 16) {
		goto end;
	}
	if(fbev_init() == -1) {
		goto end;
	}
	fbev_keyboard(keyboard, 0);
	fbev_mbutton(mouse, 0);
	fbev_mmotion(motion, 0);

	if(init_tunnel(xsz, ysz) == -1) {
		goto end;
	}

	for(;;) {
		fbev_update();
		if(quit) break;

		draw_tunnel(vmem);
	}

end:
	destroy_tunnel();
	fbev_shutdown();
	fbgfx_restore_video_mode();
	return 0;
}

static void keyboard(int key, int pressed, void *cls)
{
	if(!pressed) return;

	switch(key) {
	case 27:
	case 'q':
	case 'Q':
		exit(0);
	}
}

static void mouse(int bn, int pressed, int x, int y, void *cls)
{
}

static void motion(int x, int y, void *cls)
{
}
